﻿using EC11WebSample.Models;
using Microsoft.AspNetCore.Mvc;
using System.Diagnostics;

namespace EC11WebSample.Controllers
{
    public class HomeController : Controller
    {
        private readonly ReportService reportService;
        private const string XLSX_CONTENTTYPE = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet";

        public HomeController(ReportService reportService)
        {
            this.reportService = reportService;
        }

        [HttpGet]
        public IActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public IActionResult DataList()
        {
            return File(
                reportService.DataList(),
                XLSX_CONTENTTYPE,
                $"データ表{DateTime.Now.ToString("yyyyMMddHHmmss")}.xlsx"
                );
        }

        [HttpPost]
        public IActionResult Invoice()
        {
            return File(
                reportService.Invoice(),
                XLSX_CONTENTTYPE,
                $"納品書{DateTime.Now.ToString("yyyyMMddHHmmss")}.xlsx"
                );
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}